package cn.wustlinghang.wusthelper.internal.undergrad.api.json;

import cn.wustlinghang.mywust.core.parser.undergraduate.UndergradStudentInfoPageParser;
import cn.wustlinghang.mywust.core.request.service.undergraduate.UndergradStudentInfoApiService;
import cn.wustlinghang.mywust.data.global.StudentInfo;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.mywust.exception.ParseException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.io.IOException;

@Path("/student_info")
@ApplicationScoped
public class StudentInfoApi {
    private final UndergradStudentInfoApiService studentInfoApiService;
    private final UndergradStudentInfoPageParser studentInfoPageParser;

    public StudentInfoApi(UndergradStudentInfoApiService studentInfoApiService,
                          UndergradStudentInfoPageParser studentInfoPageParser) {
        this.studentInfoApiService = studentInfoApiService;
        this.studentInfoPageParser = studentInfoPageParser;
    }

    @GET
    @Path("/")
    public StudentInfo get(@QueryParam("cookie") @NotNull String cookie) throws IOException, ApiException, ParseException {
        return this.parse(this.agent(cookie));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws IOException, ApiException {
        return studentInfoApiService.getPage(cookie);
    }

    @POST
    @Path("/parse")
    public StudentInfo parse(String html) throws ParseException {
        return studentInfoPageParser.parse(html);
    }
}
