package cn.wustlinghang.wusthelper.internal.undergrad.services;

import cn.wustlinghang.mywust.core.request.service.auth.UndergraduateLogin;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.mywust.network.RequestClientOption;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;

@ApplicationScoped
public class LoginService {
    private final RequestClientOption option;
    private final UndergraduateLogin undergraduateLogin;

    public LoginService(RequestClientOption option,
                        UndergraduateLogin undergraduateLogin) {
        this.option = option;
        this.undergraduateLogin = undergraduateLogin;
    }

    public String login(String username, String password, boolean legacy) throws IOException, ApiException {
        if (legacy) {
            return undergraduateLogin.getLoginCookieLegacy(username, password, option);
        } else {
            return undergraduateLogin.getLoginCookie(username, password, option);
        }
    }

    public boolean verify(String cookie) throws IOException {
        return !undergraduateLogin.checkCookiesFail(cookie);
    }
}
